#include "glib.h"
#include "gindexedlist.h"
gint cmp(gconstpointer a_key, gconstpointer a_value, gconstpointer b_key, gconstpointer b_value)
{
	return GPOINTER_TO_UINT(a_value) - GPOINTER_TO_UINT(b_value);
}
gboolean remcb (gpointer key, gpointer value, gpointer user_data)
{
	if ((guint)value > (guint)user_data)
		return TRUE;
	return FALSE;
}

void print_indexed_list (gpointer key, gpointer value, gpointer user_data)
{
		printf ("%i\n", GPOINTER_TO_UINT(value));
}

int main ()
{
	int i;
	GAllocator *alloc = g_allocator_new ("My allocator", 128);
	g_list_push_allocator (alloc);

	GIndexedList *list = g_indexed_list_new (g_direct_hash, g_direct_equal);
	GIndexedList *list2 = g_indexed_list_new (g_direct_hash, g_direct_equal);

	for (i=0 ; i<10 ; i++)
		g_indexed_list_prepend (list, GUINT_TO_POINTER(i), GUINT_TO_POINTER(i));
	for (; i<20 ; i++)
		g_indexed_list_prepend (list2, GUINT_TO_POINTER(i), GUINT_TO_POINTER(i));

	g_indexed_list_concat (list2, list);
//	list = g_indexed_list_destroy (list);
	g_indexed_list_sort (list2, cmp);
//	list = g_indexed_list_copy (list2);

	g_indexed_list_move_first (list2, GUINT_TO_POINTER(7), GUINT_TO_POINTER(14));
	g_indexed_list_move_last (list2, GUINT_TO_POINTER(13), GUINT_TO_POINTER(4));
	g_indexed_list_move_after (list2, GUINT_TO_POINTER(6), GUINT_TO_POINTER(16), GUINT_TO_POINTER(18));
	
//	g_indexed_list_remove_sub_nocheck (list2, GUINT_TO_POINTER(7), GUINT_TO_POINTER(14));
	g_indexed_list_shuffle (list);

	printf ("list:\n");
	g_indexed_list_foreach (list, print_indexed_list, NULL);
	printf ("\nlist2:\n");
	g_indexed_list_foreach (list2, print_indexed_list, NULL);

	list = g_indexed_list_destroy (list);
	list2 = g_indexed_list_destroy (list2);

	g_list_pop_allocator ();
	g_allocator_free (alloc);
//	g_mem_chunk_info ();
	g_blow_chunks ();
	return 0;
}
